> ## Documentation Index
> Fetch the complete documentation index at: https://docs.topsort.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Upsert Banner Fallback

> Create or update a banner fallback for a given slot.

This replaces any fallback that already exists for the given device,
including one created with a different fallback type. The updated fallback
is exported to the auction engine on a five minute cycle with a five
minute cache, so it can take up to about 10 minutes for a shopper to see
the change. A successful response does not mean the storefront has
updated yet.



## OpenAPI

````yaml /openapi.json put /public/v1/media-service/slots/{slot_id}/fallback
openapi: 3.1.0
info:
  title: Topsort Endpoints v2 API Reference
  description: >
    In order for a storefront to be able to run auctions in Topsort and report
    auction-related events back to Topsort,

    both the `/v2/auctions` and `/v2/events` endpoints must be integrated.

    Below are the endpoint and model definitions for each.
  contact:
    email: wicha@topsort.com
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
  x-logo:
    url: https://assets.topsort.com/Topsort_logo_icon_dark.svg
    backgroundColor: '#fff'
    altText: Topsort
  version: 2.0.0
servers:
  - url: https://api.topsort.com
    description: Base API URL
security: []
tags:
  - name: Auctions
    description: >-
      An auction determines which products should be promoted based on the
      vendors' bids.
  - name: Events
    description: >-
      Events are sent to Topsort as part of the attribution and reporting
      journey.
  - name: Toptimize
    description: >
      An out-of-the-box solution for prediction, ranking, retrieval, and other
      elements of ad selection.
  - name: Toppie API
    description: Toppie management API.
  - name: Campaign API
    description: Full-featured campaign management API for banners and sponsored listings.
  - name: Catalog API
    description: Products catalog management API.
  - name: Billing API
    description: Marketplace and Vendor Billing management API.
  - name: Reporting API
    description: Marketplace, Vendor, Campaign, and product reporting API.
  - name: Invitation API
    description: Vendor invitations management API.
  - name: User API
    description: User management API.
  - name: Webhooks API
    description: Webhooks API that allows event-driven automation.
  - name: Assets API
    description: Assets management API.
  - name: Segments Service
    description: Segments Service.
  - name: Forecasting Service
    description: Toptimize Forecasting Service.
  - name: Offsite Ads API
    description: Offsite Ads API that allows to manage offsite ads campaigns.
  - name: Media API
    description: Ad configuration API.
  - name: Placement API
    description: Placement management API for sponsored brand slots.
paths:
  /public/v1/media-service/slots/{slot_id}/fallback:
    put:
      tags:
        - Media API
      summary: Upsert Banner Fallback
      description: >-
        Create or update a banner fallback for a given slot.


        This replaces any fallback that already exists for the given device,

        including one created with a different fallback type. The updated
        fallback

        is exported to the auction engine on a five minute cycle with a five

        minute cache, so it can take up to about 10 minutes for a shopper to see

        the change. A successful response does not mean the storefront has

        updated yet.
      operationId: upsert_fallback
      parameters:
        - name: slot_id
          in: path
          required: true
          schema:
            type: string
            description: The id of the slot.
            title: Slot Id
          description: The id of the slot.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/Advanced_APIs_PublicBannerFallbackCreateRequest
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Advanced_APIs_PublicBannerFallbackCreationResponse
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_HTTPValidationError'
      security:
        - Advanced_APIs_HTTPBearer: []
components:
  schemas:
    Advanced_APIs_PublicBannerFallbackCreateRequest:
      properties:
        deviceType:
          $ref: '#/components/schemas/Advanced_APIs_MediaDeviceType'
        url:
          type: string
          maxLength: 2083
          minLength: 1
          format: uri
          title: Url
        width:
          type: integer
          exclusiveMinimum: 0
          title: Width
        height:
          type: integer
          exclusiveMinimum: 0
          title: Height
        contentType:
          $ref: '#/components/schemas/Advanced_APIs_AssetMimetype'
        destination:
          $ref: '#/components/schemas/Advanced_APIs_PublicFallbackDestination'
      additionalProperties: false
      type: object
      required:
        - deviceType
        - url
        - width
        - height
        - contentType
        - destination
      title: PublicBannerFallbackCreateRequest
    Advanced_APIs_PublicBannerFallbackCreationResponse:
      properties:
        deviceType:
          $ref: '#/components/schemas/Advanced_APIs_MediaDeviceType'
        url:
          type: string
          maxLength: 2083
          minLength: 1
          format: uri
          title: Url
        width:
          type: integer
          title: Width
        height:
          type: integer
          title: Height
        contentType:
          $ref: '#/components/schemas/Advanced_APIs_AssetMimetype'
        destination:
          $ref: '#/components/schemas/Advanced_APIs_PublicFallbackDestination'
      type: object
      required:
        - deviceType
        - url
        - width
        - height
        - contentType
        - destination
      title: PublicBannerFallbackCreationResponse
    Advanced_APIs_HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Advanced_APIs_ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    Advanced_APIs_MediaDeviceType:
      type: string
      enum:
        - desktop
        - mobile
      title: MediaDeviceType
    Advanced_APIs_AssetMimetype:
      type: string
      enum:
        - image/jpeg
        - image/png
        - image/gif
        - image/webp
        - text/html
        - video/mp4
        - video/quicktime
        - application/json
        - text/vtt
      title: AssetMimetype
    Advanced_APIs_PublicFallbackDestination:
      properties:
        destinationType:
          $ref: '#/components/schemas/Advanced_APIs_CampaignEntityType'
        destinationId:
          type: string
          maxLength: 256
          title: Destinationid
      type: object
      required:
        - destinationType
        - destinationId
      title: PublicFallbackDestination
    Advanced_APIs_ValidationError:
      properties:
        loc:
          items:
            oneOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    Advanced_APIs_CampaignEntityType:
      type: string
      enum:
        - product
        - brand
        - vendor
        - url
      title: CampaignEntityType
      description: The type of the entity to be advertised.
  securitySchemes:
    Advanced_APIs_HTTPBearer:
      type: http
      description: >-
        A valid API key generated in Topsort's UI. Use the TSE API key if
        calling auctions or events API, otherwise use the TSC API key.
      scheme: bearer

````